var map;


function loaddata(data,city)
{
    data =data.replace(/\n/g,"<br/>");
    data =data.replace(/\r/g,"");
    DATAOBJ = eval('(' + data +')');
    showMap();
    
}

function initmap(city)
{
    map = new BMap.Map("allmap");            // 创建Map实例
    map.centerAndZoom(city,12);
    var navigation = new BMap.NavigationControl();
    navigation.setOffset(new BMap.Size(8, 50));
    map.addControl(navigation);
    map.addControl(new BMap.ScaleControl());
    map.addControl(new BMap.OverviewMapControl());
    //map.addControl(new BMap.MapTypeControl());   //添加地图类型控件
    map.enableScrollWheelZoom(true);     //开启鼠标滚轮缩放
    map.disableDragging();     //禁止拖拽
    
    $(".btnitemgroup1:first").addClass("btn-success");
    $(".btnitemgroup1").click(function()
                              {
                              ITEM = $(this).val();
                              $(".btnitemgroup1").removeClass("btn-success");
                              $(this).addClass("btn-success");
                              showMap();
                              });
}
function  showMap()
{
  var aqi,lat,lng,marker,icon,label;
  map.clearOverlays();
  var type = ITEM;
  data = DATAOBJ.realdata;
  var curTime = "";
  for (var i = 0; i < data.length; i++) 
  {
      aqi = parseInt(data[i].aqi);
      switch(type)
      {
        case "AQI":  value=parseInt(aqi); unit="";index = getAQILevelIndex(value);break;
        case "PM2.5": value=parseInt(data[i].pm2_5); unit="ug/m3";index = getPM25LevelIndex(value);break;
        case "PM10":  value=parseInt(data[i].pm10); unit="ug/m3";index = getPM10LevelIndex(value);break;
        case "SO2":  value=parseInt(data[i].so2); unit="ug/m3";index = getSO2LevelIndex(value);break;
        case "NO2":  value=parseInt(data[i].no2); unit="ug/m3";index = getNO2LevelIndex(value);break;
        case "O3":  value=parseInt(data[i].o3); unit="ug/m3";index = getO3LevelIndex(value);break;
        case "CO":  value=data[i].co; unit="mg/m3";index = getCOLevelIndex(value);break;
        case "INDEX":  value=parseFloat(data[i].complexindex).toFixed(3); unit="";index = getComplexIndexLevelIndex(value);break;
        case "TEMP": value=parseInt(data[i].temp);unit="℃";index = 7;break;
        case "HUMI": value=parseInt(data[i].humi);unit="%";index = 7;break;
        case "WS": value=data[i].ws;unit="m/s";index = 7;break;
        case "WD": value=parseInt(data[i].wd);unit="°";index = 7;break;
        case "PRESSURE": value=data[i].pressure;unit="hPa";index = 7;break;
      }
      var color = getlevelColor(index);
      lat = data[i].latitude;
      lng = data[i].longitude;
      time = data[i].time;
      if(time>curTime)
      {
        curTime = time;
      }
      pointtype = data[i].type;
      if(pointtype==null)
      {
        pointtype = "城市";
      }
      var desp = 
        "<table width='100%'><tr><td style='font-size:12px' valign='top'>"
        +"<table width='100%' class='fitem'>"
        +"</td></tr><tr><th>类型</th><td style='width:70px;text-align:center;'>" +pointtype
        +"</td><th>区域</th><td style='width:70px;text-align:center;'>" +data[i].region.substr(0,3)
        +"</td><th>时间</th><td  style='width:70px;text-align:center;'>" + FormatDate(data[i].time)
        +"</td></tr/><tr><th>AQI</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getAQILevelIndex(aqi)) +";color:#fff'>" + aqi
        +"</td><th>等级</th><td style='text-align:center;background-color:" + getlevelColor(getAQILevelIndex(aqi)) +";color:#fff'>" + getAQIlevelAbbr(aqi)
        +"</td><th>综指</th><td  style='width:70px;text-align:center;;background-color:" + getlevelColor(getComplexIndexLevelIndex(data[i].complexindex)) +";color:#fff'>" + parseFloat(data[i].complexindex).toFixed(3)
        +"</td></tr><tr><th>PM2.5</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getPM25LevelIndex(data[i].pm2_5)) +";color:#fff'>" + parseInt(data[i].pm2_5)
        +"</td><th>PM10</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getPM10LevelIndex(data[i].pm10)) +";color:#fff'>" + parseInt(data[i].pm10)
        +"</td><th>CO</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getCOLevelIndex(data[i].co)) +";color:#fff'>" + data[i].co
        +"</td></tr><tr><th>NO2</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getNO2LevelIndex(data[i].no2)) +";color:#fff'>" + parseInt(data[i].no2)
        +"</td><th>SO2</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getSO2LevelIndex(data[i].so2)) +";color:#fff'>" + parseInt(data[i].so2)
        +"</td><th>O3</th><td style='width:70px;text-align:center;background-color:" + getlevelColor(getO3LevelIndex(data[i].o3)) +";color:#fff'>" + parseInt(data[i].o3)                    
        +"</td></tr><tr><th>温度</th><td style='width:70px;text-align:center;'>" + parseInt(data[i].temp) + "℃"
        +"</td><th>湿度</th><td style='width:70px;text-align:center;'>" + parseInt(data[i].humi) + "%"
        +"</td><th>气压</th><td style='width:70px;text-align:center;'>" + parseInt(data[i].pressure) + "hPa"
        +"</td></tr><tr><th>风向</th><td style='width:70px;text-align:center;'>" + getWindDirectionStr(parseInt(data[i].wd))
        +"</td><th>风速</th><td style='width:70px;text-align:center;'>" + parseFloat(data[i].ws).toFixed(1) + "m/s"
        +"</td><th>降雨</th><td style='width:70px;text-align:center;'>" + parseInt(data[i].rainfall) + "mm"
        +"</td></tr></table>"
        +"</td>"
        +"<td valign='top' align='right'><td>"
        +"</tr></table><div id='citychart_" + i + "' style='width:100%;height:120px'>";
      var point = new BMap.Point(lng,lat);       
      var opts = {
        position : point,    // 指定文本标注所在的地理位置
        offset   : new BMap.Size(-15, -10)    //设置文本偏移量
      }
      var label = new BMap.Label(value, opts);  // 创建文本标注对象
      label.setStyle({
         color : "white",
         background: color,
         fontSize : "12px",
         border:'',
         width: "30px",
         textAlign:"center",
         height : "20px",
         lineHeight : "20px",
         fontFamily:"微软雅黑"
       });
      var city = data[i].cityname;
      var region = data[i].region;
      var pointname = data[i].pointname;
      var provincename = data[i].provincename;
      var name;
      if(provincename == city)
      {
         name = city;
      }
      else
      {
         name = data[i].provincename + "-" + city;
      }
      name = "";
      if(pointname != null)
      {
         name = pointname;
      }
      else 
      {
         name = name + "<a style='font-size:12px' href='cityaqi.php?city=" + city + "'> 详情>></a>";
      }
      showMapByPoint(i,name,city,region,pointname,value,color,point,desp,index);
  }
  $('#txtTime').html(curTime);
}

function showMapByPoint(i,name,city,region,pointname,value,bgcolor,point,desp,index)
{
  var opts = {
        position : point,    // 指定文本标注所在的地理位置
        offset   : new BMap.Size(-15, -10)    //设置文本偏移量
  }
  var label = new BMap.Label(value, opts);  // 创建文本标注对象
  if(index<=3 || index==7)
  {
    color = "#28004D";
  }
  else
  {
    color = "white";
  }
  if(ITEM!="WD")
  {
    label.setStyle({
     color : color,
     background: bgcolor,
     fontSize : "13px",
     border:'',
     width: "35px",
     textAlign:"center",
     height : "20px",
     lineHeight : "20px"
    });
    map.addOverlay(label);
    offseth = 12;
  }
  else
  {
      icon = getWindDirectionIcon(getWindDirectionStr(value));
      var myIcon = new BMap.Icon(icon, new BMap.Size(23,32));
      var marker = new BMap.Marker(point,{icon:myIcon});
      map.addOverlay(marker);
      offseth = 6;
      label = marker;
  }
  
    nametip = pointname;
    var len = nametip.length;
    var opts_tip = {
        position : point,    // 指定文本标注所在的地理位置
        offset   : new BMap.Size(-len*6-1, offseth)    //设置文本偏移量
    }
    var label_tip = new BMap.Label(nametip, opts_tip);  // 创建文本标注对象
    label_tip.setStyle({
                       color : "black",
                       background: 'rgba(255,255,255,0.8)',
                       fontSize : "12px",
                       border:'1px solid #999',
                       width: "auto",
                       textAlign:"center",
                       height : "18px",
                       lineHeight : "18px"
                       });
    map.addOverlay(label_tip);

  label.addEventListener("click", function () {   
  var searchInfoWindow = new BMapLib.SearchInfoWindow(map, desp, {
    title  : '<sapn style="font-size:14px">' + name + '</span>',             //标题
    width  : 308,              //宽度
    height : 240,              //高度
    enableAutoPan : true,      //自动平移,
    searchTypes :[]
    });     
    searchInfoWindow.open(point);   
    showCityPointChart(i,city,pointname);
  });    
}

function showCityPointChart(idx,city,pointname)
{
    var dataCityPoint = [];
    
    var data = DATAOBJ.historydata;
    for(var i=0;i<data.length;i++)
    {
        if(data[i].pointname!=pointname)
            continue;
        aqi = parseInt(data[i].aqi);
        
        switch(ITEM)
        {
            case "AQI":  value=aqi; unit="";index = getAQILevelIndex(value);name=ITEM;break;
            case "PM2.5":  value=parseInt(data[i].pm2_5); unit="ug/m3";index = getPM25LevelIndex(value);name=ITEM;break;
            case "PM10":  value=parseInt(data[i].pm10); unit="ug/m3";index = getPM10LevelIndex(value);name=ITEM;break;
            case "SO2":  value=parseInt(data[i].so2); unit="ug/m3";index = getSO2LevelIndex(value);name=ITEM;break;
            case "NO2":  value=parseInt(data[i].no2); unit="ug/m3";index = getNO2LevelIndex(value);name=ITEM;break;
            case "O3":  value=parseInt(data[i].o3); unit="ug/m3";index = getO3LevelIndex(value);name=ITEM;break;
            case "CO":  value=parseFloat(data[i].co); unit="mg/m3";index = getCOLevelIndex(value);name=ITEM;break;
            case "INDEX":  value=parseFloat(data[i].complexindex); unit="";index = getComplexIndexLevelIndex(value);name="综合指数";break;
            case "TEMP": value=parseInt(data[i].temp);unit="℃";index = 7;name="温度";break;
            case "HUMI": value=parseInt(data[i].humi);unit="%";index = 7;name="湿度";break;
            case "WS": value=parseFloat(data[i].ws);unit="m/s";index = 7;name="风速";break;
            case "WD": value=parseInt(data[i].wd);unit="°";index = 7;name="风向";break;
            case "PRESSURE": value=data[i].pressure;unit="hPa";index = 7;name="大气压";break;
        }
        dataCityPoint.push({
             x: convertTimeFormat(data[i].time).getTime(),
             y: value,
             color: getlevelColor(index)
        });
    }
    timetype = DATAOBJ.type;
    if(timetype=='MINUTE'){
        title=pointname + "最近两小时"+name+"变化趋势";
    }
    else if(timetype=='HOUR'){
        title=pointname + "最近24小时"+name+"变化趋势";
    }
    else if(timetype=='DAY'){
        title=pointname + "最近30日"+name+"变化趋势";
    }
    
    showChart('citychart_' + idx,name,dataCityPoint,unit,title);
}

function showChart(container,name,data,unit,title)
{ 
   
  Highcharts.setOptions({
      global: {
          useUTC: false
      }
  }); 

  var dateTypeFormat = '%Y-%m-%d %H:%M';
  var markerShowFlag = false;

  $('#' + container).highcharts({       
    chart: {
      type: 'column',
            zoomType: 'x',
            spacingLeft: 0,
            spacingRight: 0
        },
        title: {
            text: title,
            style:{
                fontSize:'12px'
            }
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats:{
            millisecond: '%H:%M:%S.%L',
            second: '%H:%M:%S',
            minute: '%H:%M',
            hour: '%H:%M',
            day: '%m-%d',
            week: '%m-%d',
            month: '%Y-%m',
            year: '%Y'
            }               
        },
        yAxis:{
            title: {
                text: ''
            },
            min:0
        },
        tooltip: {
            //shared: true,
            enabled: true,
            formatter: function() {
                var tip = '' + Highcharts.dateFormat(dateTypeFormat, this.x) +'<br/>' + 
                this.series.name +': <b>'+ this.y + '</b>' + unit;
                if(this.point.primary_pollutant!=null)
                {
                    tip = tip + "<br/>首要污染物：" + this.point.primary_pollutant;
                }
                return tip;

            }
        },
        plotOptions:{             
          series:{
            marker: {
                  enabled: markerShowFlag,
                    radius:5
              },
              enableMouseTracking:true,
            turboThreshold: 0
          } 
        },
        legend: {
            enabled:false
        },
        credits: {
            enabled:false
        },
        series: [{
            name: name,
            data: data
        }]
    });
}







