var heights = $(window).height() + 200;
$('.loading').css('line-height', heights + "px");
/**
 * JS对象数组排序
 */
function createComparionFunASC(propertyName)
{
    return function(object1,object2)
    {
        
        var value1=parseFloat(object1[propertyName]);
        
        var value2=parseFloat(object2[propertyName]);
        
        return value1 - value2;
    }
}
/*
 * 加载数据
 */
function loaddata(data,menusstr) {
	var indexdata = data;
	indexdata = eval("(" + indexdata + ")");
    var menusstr=menusstr;
    if(menusstr!=null&&menusstr!="null"&&menusstr!=""){
        var menus=menusstr.split(",");
        if($.inArray("实时天气", menus)==-1){
            $(".sstq").hide();
        }
        if($.inArray("未来五天预报", menus)==-1){
            $(".wl5t").hide();
        }
        if($.inArray("预警预报", menus)==-1){
            $(".yjyb").hide();
        }
    }
	datas = indexdata;
	datass = indexdata.neighbor_city;
	datasss = indexdata.point;
	console.info(datas);
    dayaqi = indexdata.dayaqi;
    forecastaqi = indexdata.aqi_forecast;
    
    datas.point.sort(createComparionFunASC('aqi'));
    
    showDayAQI();
	var myDate = convertTimeFormat(datas.aqi.time);
	var newDate = new Date();
	var myminute = newDate.getMinutes();
	var myhour = newDate.getHours();
	if (myminute < 33) {
		var nextTime = myhour + ":33";
	} else {
		myhour = 1 + myhour;
		var nextTime = myhour + ":33";
	}
    
	$('.updatatime').text(myDate.getHours());
	$('.nexttime').text(nextTime);
	$('.nowtime').html(datas.weather_data[0].date.replace("日","日<br/>"));
	$('.tqicon').attr('src', datas.weather_realtime.weather_icon);
	$('.wd').text(datas.weather_data[0].temperature);
    $('.tq').text(datas.weather_realtime.weather);
	$('.fl').text(datas.weather_realtime.wd + datas.weather_realtime.wl + '级');
	$('.sd').text(datas.weather_realtime.humi);
	$('.aqi').text(datas.aqi.aqi);
	$('.aqilevel').css('background-color', getAQIColor(datas.aqi.aqi));
	$('.aqilevel').text(datas.aqi.quality);
	$('.mainwr').text('首要污染物：' + formatStr(datas.aqi.primary_pollutant));
    $('.day_aqi').html('AQI指数：' + datas.aqi.day_aqi + '，污染等级：<span style="background:' + getAQIColor(datas.aqi.day_aqi) + '">' + getAQIlevel(datas.aqi.day_aqi) + '</span>，首要污染物：' + datas.aqi.day_poll);
    $('.span_aqi').html(datas.aqi.day_aqi);
    $('.span_quality').html('<span style="background:' + getAQIColor(datas.aqi.day_aqi) + ';padding:1px 10px;border-radius:5px">' + getAQIlevel(datas.aqi.day_aqi) + '</span>');
    $('.span_primary_pollutant').html(datas.aqi.day_poll);
    if(indexdata.cityinfo.rankflag==1){
        $('.houraqirank').text(75-datas.rank.hourrank);
        $('.hourzhrank').text(75-datas.rank.dayrank);``
        $('.monthrank').text(75-datas.rank.monthrank);
        $('.yearrank').text(75-datas.rank.yearrank);
        $('.city_rankflag').text(74);
    }else{
        $('.houraqirank').text(338-datas.rank.hourrank_338);
        $('.hourzhrank').text(338-datas.rank.dayrank_338);
        $('.monthrank').text(338-datas.rank.monthrank_338);
        $('.yearrank').text(338-datas.rank.yearrank_338);
        $('.city_rankflag').text(337);
    }
    $("#rankdate").text(datas.rank.date);
    $('.cent-bott').empty("");
    
    pm25logo='';
    pm10logo='';
    so2logo='';
    no2logo='';
    cologo='';
    o3logo='';
    switch(datas.aqi.primary_pollutant)
    {
        case 'PM2.5':
            pm25logo = "<br/><img src='img/main_pollutantlogo.png' style='width:8px;margin-top:-14px;'>";
            break;
        case 'PM10':
            pm10logo = "<br/><img src='img/main_pollutantlogo.png' style='width:8px;margin-top:-14px;'>";
            break;
        case 'SO2':
            so2logo = "<br/><img src='img/main_pollutantlogo.png' style='width:8px;margin-top:-14px;'>";
            break;
        case 'NO2':
            no2logo = "<br/><img src='img/main_pollutantlogo.png' style='width:8px;margin-top:-14px;'>";
            break;
        case 'CO':
            cologo = "<br/><img src='img/main_pollutantlogo.png' style='width:8px;margin-top:-14px;'>";
            break;
        case 'O3':
            o3logo = "<br/><img src='img/main_pollutantlogo.png' style='width:8px;margin-top:-14px;'>";
            break;
    }
    
	$('.cent-bott').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getPM25LevelIndex(datas.aqi.pm2_5)) + ";'>PM2.5</div><div class='bott-1-2'>" + parseInt(datas.aqi.pm2_5) + pm25logo + "</div></div>");
	$('.cent-bott').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getPM10LevelIndex(datas.aqi.pm10)) + ";'>PM10</div><div class='bott-1-2'>" + parseInt(datas.aqi.pm10) + pm10logo + "</div></div>");
	$('.cent-bott').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getSO2LevelIndex(datas.aqi.so2)) + ";'>SO2</div><div class='bott-1-2'>" + parseInt(datas.aqi.so2) + so2logo + "</div></div>");
	$('.cent-bott').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getNO2LevelIndex(datas.aqi.no2)) + ";'>NO2</div><div class='bott-1-2'>" + parseInt(datas.aqi.no2) + no2logo + "</div></div>");
	$('.cent-bott').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getCOLevelIndex(datas.aqi.co)) + ";'>CO</div><div class='bott-1-2'>" + parseFloat(datas.aqi.co) + cologo + "</div></div>");
	$('.cent-bott').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getO3LevelIndex(datas.aqi.o3)) + ";'>O3</div><div class='bott-1-2'>" + parseInt(datas.aqi.o3) + o3logo + "</div></div>");

	if (datas.aqi.quality == '优') {
		$('.cent-bg').css('background-image', 'url(img/bg.png)');
	} else if (datas.aqi.quality == '良') {
		$('.cent-bg').css('background-image', 'url(img/bg2.png)');
	} else if (datas.aqi.quality == '轻度污染') {
		$('.cent-bg').css('background-image', 'url(img/bg3.png)');
	} else if (datas.aqi.quality == '中度污染') {
		$('.cent-bg').css('background-image', 'url(img/bg4.png)');
	} else if (datas.aqi.quality == '重度污染') {
		$('.cent-bg').css('background-image', 'url(img/bg5.png)');
	} else if (datas.aqi.quality == '严重污染') {
		$('.cent-bg').css('background-image', 'url(img/bg6.png)');
	}

    $('.cent-bottpoint').empty("");
	$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getPM25LevelIndex(datass[0].pm2_5)) + ";'>PM2.5</div><div class='bott-1-2'>" + parseInt(datass[0].pm2_5) + "</div></div>");
	$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getPM10LevelIndex(datass[0].pm10)) + ";'>PM10</div><div class='bott-1-2'>" + parseInt(datass[0].pm10) + "</div></div>");
	$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getSO2LevelIndex(datass[0].so2)) + ";'>SO2</div><div class='bott-1-2'>" + parseInt(datass[0].so2) + "</div></div>");
	$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getNO2LevelIndex(datass[0].no2)) + ";'>NO2</div><div class='bott-1-2'>" + parseInt(datass[0].no2) + "</div></div>");
	$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getCOLevelIndex(datass[0].co)) + ";'>CO</div><div class='bott-1-2'>" + parseFloat(datass[0].co) + "</div></div>");
	$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getO3LevelIndex(datass[0].o3)) + ";'>O3</div><div class='bott-1-2'>" + parseInt(datass[0].o3) + "</div></div>");
	$('.wdpoint').text(datass[0].temp + "℃");
	$('.flpoint').text(datass[0].winddirection + "" + getWindLevel(datass[0].windspeed) + "级");
	$('.sdpoint').text(datass[0].humi);
	$('.pointaqi').text(datass[0].aqi);
	$('.pointaqi').css('color', getAQIColor(datass[0].aqi));
	$('.pointaqilevel').css('background-color', getAQIColor(datass[0].aqi));
	$('.pointaqilevel').text(datass[0].quality);
    $('.tab-list').empty("");
	$('.tab-list').append("<tr style='border-top: 1px solid #EFEFF4;font-size: 12px; color: #3388FB;'><td class='border-r'>排序</td><td class='border-r'>站点</td><td class='border-r'>AQI</td><td class='border-r'>等级</td><td class='border-r'>变化率</td><td style='display:none' class='pp'>首要污染物</td></tr>");
    var k=0;
	for (var i = 0; i < datas.point.length; i++) {
		if (datas.point[i].pointlevel == '国控点'||datas.point[i].pointlevel == '城市') {
			var polluteLeval = datas.point[i].quality.substring(0, 2);
			if (k<= 3) {
				$('.tab-list').append("<tr><td><div style='background-color: limegreen;' class='rank'>" + (k + 1) + "</div></td><td style='text-align:left'>" + datas.point[i].pointname + "</td><td>" + datas.point[i].aqi + "</td><td style='color: " + getAQIColor(datas.point[i].aqi) + ";'>" + polluteLeval + "</td><td>" + Math.abs(Math.abs(Math.abs((datas.point[i].ratio * 100).toFixed(2)))) + "%<img class='arrow-image' src=''></td><td style='display:none' class='pp'>" + formatStr(datas.point[i].primary_pollutant) + "</td></tr>");
				if (datasss[i].ratio > 0) {
					$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
				} else {
					$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
				}
			} else if (k <= 10) {

				$('.tab-list').append("<tr><td><div style='background-color: gold;' class='rank'>" + (k + 1) + "</div></td><td style='text-align:left'>" + datas.point[i].pointname + "</td><td>" + datas.point[i].aqi + "</td><td style='color: " + getAQIColor(datas.point[i].aqi) + ";'>" + polluteLeval + "</td><td>" + Math.abs((datas.point[i].ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td><td style='display:none' class='pp'>" + formatStr(datas.point[i].primary_pollutant) + "</td></tr>");
				if (datasss[i].ratio > 0) {
					$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
				} else {
					$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
				}
			} else {
				$('.tab-list').append("<tr><td><div style='background-color: brown;' class='rank'>" + (k+ 1) + "</div></td><td style='text-align:left'>" + datas.point[i].pointname + "</td><td>" + datas.point[i].aqi + "</td><td style='color: " + getAQIColor(datas.point[i].aqi) + ";'>" + polluteLeval + "</td><td>" + Math.abs((datas.point[i].ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td><td style='display:none' class='pp'>" + formatStr(datas.point[i].primary_pollutant) + "</td></tr>");
				if (datasss[i].ratio > 0) {
					$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
				} else {
					$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
				}
			}
            k++;
		}
	}
	$('.gkd').click(function() {
		$(this).addClass('checked');
		$(this).siblings().removeClass('checked');
		$('.tab-list').children().remove();
		$('.tab-list').append("<tr style='border-top: 1px solid #EFEFF4;font-size: 12px; color: #3388FB;'><td class='border-r'>排序</td><td class='border-r'>站点</td><td class='border-r'>AQI</td><td class='border-r'>等级</td><td class='border-r'>变化率</td><td style='display:none' class='pp'>首要污染物</td></tr>");
        var k=0;
		for (var i = 0; i < datas.point.length; i++) {
			console.info(parseFloat(datasss[i].ratio) * 100);
			if (datas.point[i].pointlevel == '国控点'||datas.point[i].pointlevel == '城市') {
				var polluteLeval = datas.point[i].quality.substring(0, 2);
				if (k <= 3) {
					$('.tab-list').append("<tr><td><div style='background-color: limegreen;' class='rank'>" + (k + 1) + "</div></td><td style='text-align:left'>" + datas.point[i].pointname + "</td><td>" + datas.point[i].aqi + "</td><td style='color: " + getAQIColor(datas.point[i].aqi) + ";'>" + polluteLeval + "</td><td>" + Math.abs((datas.point[i].ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td><td style='display:none' class='pp'>" + formatStr(datas.point[i].primary_pollutant) + "</td></tr>");
					if (datasss[i].ratio > 0) {
						$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
					} else {
						$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
					}
				} else if (k <= 10) {
					$('.tab-list').append("<tr><td><div style='background-color: gold;' class='rank'>" + (k + 1) + "</div></td><td style='text-align:left'>" + datas.point[i].pointname + "</td><td>" + datas.point[i].aqi + "</td><td style='color: " + getAQIColor(datas.point[i].aqi) + ";'>" + polluteLeval + "</td><td>" + Math.abs((datas.point[i].ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td><td style='display:none' class='pp'>" + formatStr(datas.point[i].primary_pollutant) + "</td></tr>");
					if (datasss[i].ratio > 0) {
						$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
					} else {
						$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
					}
				} else {
					$('.tab-list').append("<tr><td><div style='background-color: brown;' class='rank'>" + (k + 1) + "</div></td><td style='text-align:left'>" + datas.point[i].pointname + "</td><td>" + datas.point[i].aqi + "</td><td style='color: " + getAQIColor(datas.point[i].aqi) + ";'>" + polluteLeval + "</td><td>" + Math.abs((datas.point[i].ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td><td style='display:none' class='pp'>" + formatStr(datas.point[i].primary_pollutant) + "</td></tr>");
					if (datasss[i].ratio > 0) {
						$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
					} else {
						$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
					}
				}
                k++;
			}
		}
    });
	$('.skd').click(function() {
		$(this).addClass('checked');
		$(this).siblings().removeClass('checked');
		$('.tab-list').children().remove();
		$('.tab-list').append("<tr style='border-top: 1px solid #EFEFF4;font-size: 12px; color: #3388FB;'><td class='border-r'>排序</td><td class='border-r'>站点</td><td class='border-r'>综合指数</td><td class='border-r'>变化率</td></tr>");
		var i = 0;
		for (var j = 0; j < datas.complexindexratio.length; j++) 
		{
			if (datas.complexindexratio[j].type == 'DAY') 
			{
				if (i <= 3) 
				{
					bgcolor = "limegreen";
				} 
				else if (i <= 10) 
				{
					bgcolor = "gold";
				} 
				else 
				{
					bgcolor = "brown";
				}
				$('.tab-list').append("<tr><td><div style='background-color: " + bgcolor + ";' class='rank'>" + (i + 1) + "</div></td><td style='text-align:left'>" + datas.complexindexratio[j].pointname + "</td><td>" + (parseFloat(datas.complexindexratio[j].complex_index)).toFixed(3) + "</td><td>" + Math.abs((datas.complexindexratio[j].complex_index_ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td></tr>");
				if (datas.complexindexratio[j].complex_index_ratio > 0) 
				{
					$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
				} 
				else 
				{
					$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
				}
				i++;
			}
		}
    });
	$('.mkd').click(function() {
		$(this).addClass('checked');
		$(this).siblings().removeClass('checked');
		$('.tab-list').children().remove();
		$('.tab-list').append("<tr style='border-top: 1px solid #EFEFF4;font-size: 12px; color: #3388FB;'><td class='border-r'>排序</td><td class='border-r'>站点</td><td class='border-r'>综合指数</td><td class='border-r'>变化率</td></tr>");
		var i = 0;
		for (var j = 0; j < datas.complexindexratio.length; j++) 
		{
			if (datas.complexindexratio[j].type == 'MONTH') 
			{
				if (i <= 3) 
				{
					bgcolor = "limegreen";
				} 
				else if (i <= 10) 
				{
					bgcolor = "gold";
				} 
				else 
				{
					bgcolor = "brown";
				}
				$('.tab-list').append("<tr><td><div style='background-color: " + bgcolor + ";' class='rank'>" + (i + 1) + "</div></td><td style='text-align:left'>" + datas.complexindexratio[j].pointname + "</td><td>" + (parseFloat(datas.complexindexratio[j].complex_index)).toFixed(3) + "</td><td>" + Math.abs((datas.complexindexratio[j].complex_index_ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td></tr>");
				if (datas.complexindexratio[j].complex_index_ratio > 0) 
				{
					$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
				} 
				else 
				{
					$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
				}
				i++;
			}
		}
    });
    $('.ykd').click(function() {
		$(this).addClass('checked');
		$(this).siblings().removeClass('checked');
		$('.tab-list').children().remove();
		$('.tab-list').append("<tr style='border-top: 1px solid #EFEFF4;font-size: 12px; color: #3388FB;'><td class='border-r'>排序</td><td class='border-r'>站点</td><td class='border-r'>综合指数</td><td class='border-r'>变化率</td></tr>");
		var i = 0;
		for (var j = 0; j < datas.complexindexratio.length; j++) 
		{
			if (datas.complexindexratio[j].type == 'YEAR') 
			{
				if (i <= 3) 
				{
					bgcolor = "limegreen";
				} 
				else if (i <= 10) 
				{
					bgcolor = "gold";
				} 
				else 
				{
					bgcolor = "brown";
				}
				$('.tab-list').append("<tr><td><div style='background-color: " + bgcolor + ";' class='rank'>" + (i + 1) + "</div></td><td style='text-align:left'>" + datas.complexindexratio[j].pointname + "</td><td>" + (parseFloat(datas.complexindexratio[j].complex_index)).toFixed(3) + "</td><td>" + Math.abs((datas.complexindexratio[j].complex_index_ratio * 100).toFixed(2)) + "%<img class='arrow-image' src=''></td></tr>");
				if (datas.complexindexratio[j].complex_index_ratio > 0) 
				{
					$(".arrow-image").eq(i).attr("src", "img/arrow-up.png");
				} 
				else 
				{
					$(".arrow-image").eq(i).attr("src", "img/arrow-down.png");
				}
				i++;
			}
		}
    });
    $('.tqyb').html("<span style='font-size:18px;'>未来五天空气质量及天气预报</span><br>");
	for (var i = 0; i < 5; i++) {
		if (datas.aqi_forecast[i] == undefined) {
			$('.tqyb').append("<div class='tqdiv'  ><span>" + getybdate(datas.weather_forecast[i].date, 1) + "</span><br><div style='width: 90%; margin-left: 5%; " + getAQIStyle(0) + "; border-radius: 5px;'>" + getAQIlevel(0) + "</div><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].tq + "</span><span style='overflow:hidden;width:100%;height:22px;display:block;'><img src='" + datas.weather_forecast[i].weather_icon + "'/></span><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].temp1 + "~" + datas.weather_forecast[i].temp2 + "℃</span><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].wd + "</span><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].ws + "</span></div>");
		} else {
			var aqilevel = getAQIlevel(datas.aqi_forecast[i].aqi).substring(0, 2);
			$('.tqyb').append("<div class='tqdiv'  ><span>" + getybdate(datas.weather_forecast[i].date, 1) + "</span><br><div style='width: 76%; margin-left: 12%; " + getAQIStyle(datas.aqi_forecast[i].aqi) + "; border-radius: 5px;'>" + aqilevel + "</div><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].tq + "</span><span style='overflow:hidden;width:100%;height:22px;display:block;'><img src='" + datas.weather_forecast[i].weather_icon + "'/></span><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].temp1 + "~" + datas.weather_forecast[i].temp2 + "℃</span><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].wd + "</span><span style='overflow:hidden;width:100%;height:17px;display:block;'>" + datas.weather_forecast[i].ws + "</span></div>");
		}
	}

	$('.cent2-1-1').click(function() {
		$('.cent-bottpoint').children().remove();
		var datai = $(this).attr('data-i');
		$(this).addClass('checked');
		for (var i = 0; i < datass.length; i++) {
			if (i == datai) {
				$('.pointaqi').text(datass[i].aqi);
				$('.pointaqi').css('color', getAQIColor(datass[i].aqi));
				$('.pointaqilevel').css('background-color', getAQIColor(datass[i].aqi));
				$('.pointaqilevel').text(datass[i].quality);
				$(this).siblings().removeClass('checked');
				$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getPM25LevelIndex(datass[i].pm2_5)) + ";'>PM2.5</div><div class='bott-1-2'>" + parseInt(datass[i].pm2_5) + "</div></div>");
				$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getPM10LevelIndex(datass[i].pm10)) + ";'>PM10</div><div class='bott-1-2'>" + parseInt(datass[i].pm10) + "</div></div>");
				$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getSO2LevelIndex(datass[i].so2)) + ";'>SO2</div><div class='bott-1-2'>" + parseInt(datass[i].so2) + "</div></div>");
				$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getNO2LevelIndex(datass[i].no2)) + ";'>NO2</div><div class='bott-1-2'>" + parseInt(datass[i].no2) + "</div></div>");
				$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getCOLevelIndex(datass[i].co)) + ";'>CO</div><div class='bott-1-2'>" + parseInt(datass[i].co) + "</div></div>");
				$('.cent-bottpoint').append("<div class='bott-1'><div class='bott-1-1' style='background-color: " + getlevelColor(getO3LevelIndex(datass[i].o3)) + ";'>O3</div><div class='bott-1-2'>" + parseInt(datass[i].o3) + "</div></div>");
				$('.wdpoint').text(datass[i].temp + "℃");
				$('.flpoint').text(datass[i].winddirection + "" + getWindLevel(datass[0].windspeed) + "级");
				$('.sdpoint').text(datass[i].humi);
			}
		}
	});

	var type = "AQI";
	changePolluttype(type);
	function changePolluttype(val) {
		$('.cityname').css('color', getAQIColor(datasss[0].aqi));
		$('.cityname').text(datasss[0].cityname);

		var citylist = "";
		if (val == "AQI") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].aqi + "},";
			}
		} else if (val == "PM2.5") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].pm2_5 + "},";
			}

		} else if (val == "PM10") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].pm10 + "},";
			}

		} else if (val == "SO2") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].so2 + "},";
			}

		} else if (val == "NO2") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].no2 + "},";
			}

		} else if (val == "CO") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].co + "},";
			}

		} else if (val == "O3") {
			for (var i = 0; i < datass.length; i++) {
				citylist = citylist + " {name: '" + datass[i].cityname + "市', value: " + datass[i].o3 + "},";
			}

		}
		citylist = "[" + citylist + "]";
		citylist = eval("(" + citylist + ")");
		console.info(citylist);
	}
	$('.loading').remove();

	$("#dLabel").click(function() {
		$(".showUl").toggle();
		$(".showUl").css("z-index", "9999");
	});
	$(".pollutestyle").click(function() {
		$(".showUl").toggle();
		var val = $(this).attr("data-val");
		$("#dLabel").text(val);
		$(".pollutestyle").css("backgroundcolor", "#ddd");
		changePolluttype(val);
		$("#dLabel").append("<span class='caret'></span>");
	});
}

function showDayAQI()
{
    var t = $('#calendartable');
    if(dayaqi==null)
        return;
    for(i=0;i<dayaqi.length;i++){
        
        day = dayaqi[i]['time'];
        day = convertTimeFormat(day);
        day = day.getFullYear() + '-' + (day.getMonth() + 1) + '-' + day.getDate();
        aqi = parseInt(dayaqi[i]['aqi']);
        color = getAQIColor(aqi);
        t.find('td[abbr="' + day + '"]').addClass('gblevel').css('backgroundColor', color);
        t.find('td[abbr="' + day + '"]').attr('aqi',aqi);
        t.find('td[abbr="' + day + '"]').attr('primary_pollutant',dayaqi[i]['primary_pollutant']);
    }

    forecastaqi = null;
    if(forecastaqi==null)
        return;
    for(i=0;i<forecastaqi.length;i++){
        
        day = forecastaqi[i]['forecast_time'];
        day = convertTimeFormat(day);
        day = day.getFullYear() + '-' + (day.getMonth() + 1) + '-' + day.getDate();
        aqi = parseInt(forecastaqi[i]['aqi']);
        color = getAQIColor(aqi);
        t.find('td[abbr="' + day + '"]').addClass('gblevel').css('backgroundColor', color);
        t.find('td[abbr="' + day + '"]').attr('aqi',aqi);
        t.find('td[abbr="' + day + '"]').attr('primary_pollutant',forecastaqi[i]['primary_pollutant']);
    }
}
