  
  /*
   * 转换时间格式
   */
  function convertTimeFormat(time) {
  	if (time != null) {
  		time = time.replace("-", "/");
  		time = time.replace("-", "/");
  		return new Date(time);
  	}
  	return null;
  }

  function formatStr(str) {
  	if (str == null) {
  		return '无';
  	} else {
  		return str;
  	}
  }

  function getybdate(dates, i) {
  	if (i == 1) {
  		var result = dates.match(/（(.*)）/i);
  		return result[1];
  	} else {
  		return dates.substr(0, 4);
  	}
  }

    function getWindLevelByStr(wd)
    {
        var wid = 0;
        switch(wd)
        {
            case '北风':wid = 0;break;
            case '东北风':wid = 1;break;
            case '东风':wid = 2;break;
            case '东南风':wid = 3;break;
            case '南风':wid = 4;break;
            case '西南风':wid = 5;break;
            case '西风':wid = 6;break;
            case '西北风':wid = 7;break;
        }
        return wid;
    }

  //根据风速得到风力等级
  function getWindLevel(speed) {
  	if (speed < 1) {
  		return 0;
  	} else if (speed >= 1 && speed <= 5) {
  		return 1;
  	} else if (speed >= 6 && speed <= 11) {
  		return 2;
  	} else if (speed >= 12 && speed <= 19) {
  		return 3;
  	} else if (speed >= 20 && speed <= 28) {
  		return 4;
  	} else if (speed >= 29 && speed <= 38) {
  		return 5;
  	} else if (speed >= 39 && speed <= 49) {
  		return 6;
  	} else if (speed >= 50 && speed <= 61) {
  		return 7;
  	} else if (speed >= 62 && speed <= 74) {
  		return 8;
  	} else if (speed >= 75 && speed <= 88) {
  		return 9;
  	} else if (speed >= 89 && speed <= 102) {
  		return 10;
  	} else if (speed >= 103 && speed <= 117) {
  		return 11;
  	} else if (speed > 117) {
  		return 12;
  	}
  }

  //根据aqi得到对应颜色
  function getAQIColor(aqi) {
  	if (aqi <= 0) {
  		color = "#6E6E6E";
  	} else if (aqi <= 50) {
  		color = "#43ce17";
  	} else if (aqi <= 100) {
  		color = "#efdc31";
  	} else if (aqi <= 150) {
  		color = "#fa0";
  	} else if (aqi <= 200) {
  		color = "#ff401a";
  	} else if (aqi <= 300) {
  		color = "#d20040";
  	} else {
  		color = "#9c0a4e";
  	}
  	return color;
  }

  //根据aqi得到污染等级
  function getAQIlevel(aqi) {
  	if (aqi <= 0) {
  		color = "无";
  	} else if (aqi <= 50) {
  		color = "优";
  	} else if (aqi <= 100) {
  		color = "良";
  	} else if (aqi <= 150) {
  		color = "轻度污染";
  	} else if (aqi <= 200) {
  		color = "中度污染";
  	} else if (aqi <= 300) {
  		color = "重度污染";
  	} else {
  		color = "严重污染";
  	}
  	return color;
  }

    //根据aqi得到污染等级
    function getAQIlevelAbbr(aqi) {
    if (aqi <= 0) {
        color = "无";
    } else if (aqi <= 50) {
        color = "优";
    } else if (aqi <= 100) {
        color = "良";
    } else if (aqi <= 150) {
        color = "轻度";
    } else if (aqi <= 200) {
        color = "中度";
    } else if (aqi <= 300) {
        color = "重度";
    } else {
        color = "严重";
    }
    return color;
    }
//根据aqi得到按钮样式
  function getAQIStyle(aqi) {
  	if (aqi <= 0 || aqi == null || aqi == '') {
  		styles = 'background-color:#6E6E6E;color:white;';
  	} else if (aqi <= 50) {
  		styles = 'background-color:#43ce17;color:white;';
  	} else if (aqi <= 100) {
  		styles = 'background-color:#efdc31;color:white;';
  	} else if (aqi <= 150) {
  		styles = 'background-color:#fa0;color:white;';
  	} else if (aqi <= 200) {
  		styles = 'background-color:#ff401a;color:white;';
  	} else if (aqi <= 300) {
  		styles = 'background-color:#d20040;color:white;';
  	} else {
  		styles = 'background-color:#9c0a4e;color:white;';
  	}
  	return styles;
  }

  function getAQILevelIndex(aqi) {
  	if (aqi <= 0) {
  		color = 0;
  	} else if (aqi <= 50) {
  		color = 1;
  	} else if (aqi <= 100) {
  		color = 2;
  	} else if (aqi <= 150) {
  		color = 3;
  	} else if (aqi <= 200) {
  		color = 4;
  	} else if (aqi <= 300) {
  		color = 5;
  	} else {
  		color = 6;
  	}
  	return color;
  }

//根据污染等级得到对应颜色
function getlevelColor(level) {
    if (level == 0) {
        color = "#6E6E6E";
    } else if (level == 1) {
        color = "#43ce17";
    } else if (level == 2) {
        color = "#efdc31";
    } else if (level == 3) {
        color = "#fa0";
    } else if (level == 4) {
        color = "#ff401a";
    } else if (level == 5) {
        color = "#d20040";
    } else if (level == 6) {
        color = "#9c0a4e";
    }
    else{
        color = "#97CBFF";
    }
    return color;
}

    // 根据综合指数得到对应污染等级
   function getComplexIndexLevelIndex(complexindex) {
    if (complexindex <= 5) {
        level = 1;
    } else if (complexindex <= 6) {
        level = 2;
    } else if (complexindex <= 8) {
        level = 3;
    } else if (complexindex <= 9) {
        level = 4;
    } else if (complexindex <= 10) {
        level = 5;
    } else {
        level = 6;
    }
    return level;
   }

  //根据pm2.5得到对应污染等级
  function getPM25LevelIndex(pm2_5) {
  	if (pm2_5 <= 35) {
  		level = 1;
  	} else if (pm2_5 <= 75) {
  		level = 2;
  	} else if (pm2_5 <= 115) {
  		level = 3;
  	} else if (pm2_5 <= 150) {
  		level = 4;
  	} else if (pm2_5 <= 250) {
  		level = 5;
  	} else {
  		level = 6;
  	}
  	return level;
  }
  //		根据pm10得到对应污染等级
  function getPM10LevelIndex(pm10) {
  	if (pm10 <= 50) {
  		level = 1;
  	} else if (pm10 <= 150) {
  		level = 2;
  	} else if (pm10 <= 250) {
  		level = 3;
  	} else if (pm10 <= 350) {
  		level = 4;
  	} else if (pm10 <= 420) {
  		level = 5;
  	} else {
  		level = 6;
  	}
  	return level;
  }

  /**
   *根据so2得到对应污染等级
   */
  function getSO2LevelIndex(so2) {
  	if (so2 <= 150) {
  		level = 1;
  	} else if (so2 <= 500) {
  		level = 2;
  	} else if (so2 <= 650) {
  		level = 3;
  	} else if (so2 <= 800) {
  		level = 4;
  	} else {
  		level = 5;
  	}
  	return level;
  }
  //		根据no2得到对应污染等级
  function getNO2LevelIndex(no2) {
  	if (no2 <= 100) {
  		level = 1;
  	} else if (no2 <= 200) {
  		level = 2;
  	} else if (no2 <= 700) {
  		level = 3;
  	} else if (no2 <= 1200) {
  		level = 4;
  	} else if (no2 <= 2340) {
  		level = 5;
  	} else {
  		level = 6;
  	}
  	return level;
  }
  //		根据o3得到对应污染等级
  function getO3LevelIndex(o3) {
  	if (o3 <= 160) {
  		level = 1;
  	} else if (o3 <= 200) {
  		level = 2;
  	} else if (o3 <= 300) {
  		level = 3;
  	} else if (o3 <= 400) {
  		level = 4;
  	} else if (o3 <= 800) {
  		level = 5;
  	} else {
  		level = 6;
  	}
  	return level;
  }
  //		根据co得到对应污染等级
  function getCOLevelIndex(co) {
  	if (co <= 5) {
  		level = 1;
  	} else if (co <= 10) {
  		level = 2;
  	} else if (co <= 35) {
  		level = 3;
  	} else if (co <= 60) {
  		level = 4;
  	} else if (co <= 90) {
  		level = 5;
  	} else {
  		level = 6;
  	}
  	return level;
  }


/**
 * 获取风向
 */
function getWindDirectionStr(wd)
{
    var wdstr = '';
    if(wd==null)
    {
        wdstr = '-';
    }
    else if(wd<=22.5 || wd>=337.5)
    {
        wdstr = '北风';
    }
    else if(wd>22.5 && wd<=67.5)
    {
        wdstr = '东北风';
    }
    else if(wd>67.5 && wd<=112.5)
    {
        wdstr = '东风';
    }
    else if(wd>112.5 && wd<=157.5)
    {
        wdstr = '东南风';
    }
    else if(wd>157.5 && wd<=202.5)
    {
        wdstr = '南风';
    }
    else if(wd>202.5 && wd<=247.5)
    {
        wdstr = '西南风';
    }
    else if(wd>247.5 && wd<=292.5)
    {
        wdstr = '西风';
    }
    else if(wd>292.5 && wd<=337.5)
    {
        wdstr = '西北风';
    }
    return wdstr;
  }

/*获取风向图标*/
function getWindDirectionIcon(wd)
{
    var wid = 0;
    var url = null;
    switch(wd)
    {
        case '东风':wid = 1;break;
        case '东南风':wid = 2;break;
        case '南风':wid = 3;break;
        case '西南风':wid = 4;break;
        case '西风':wid = 5;break;
        case '西北风':wid = 6;break;
        case '北风':wid = 7;break;
        case '东北风':wid = 8;break;
    }
    if(wid>0)
    {
        url = 'img/arrow/' + wid + '.png';
    }
    return url;
}

  /*时间格式化*/
  function FormatDate (strTime) {
    //time = convertTimeFormat(strTime);
    //return time.pattern('HH时');
    return strTime.substr(11,5);
  }

  //获取字符串长度 区分中英文, 中文两个字节
    String.prototype.getBytes = function () {
    var cArr = this.match(/[^\x00-\xff]/ig);
    return this.length + (cArr == null ? 0 : cArr.length);
    };
    //截取字符串长度 区分中英文, 中文两个字节. 超出部分中指定字符串代替 需引用 String.prototype.getBytes
    String.prototype.cutBytes = function (strLen, replaceStr) {
    var str = this.toString();
    if (str.getBytes() <= strLen)
    return str;
    var returnStr = "";
    var tempLen = 0;
    for (var i = 0; i < str.length; i++) {
    var tempChar = str[i].match(/[^\x00-\xff]/ig);
    returnStr += str[i];
    tempLen += tempChar == null ? 1 : 2;
    if (tempLen >= strLen) {
    return i + 1 < str.length ? returnStr + replaceStr : returnStr;
    }
    }
    return "";
    };

    /**      <br>
    * 对Date的扩展，将 Date 转化为指定格式的String       <br>
    * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q) 可以用 1-2 个占位符       <br>
    * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)       <br>
    * eg:       <br>
    * (new Date()).pattern("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423       <br>
    * (new Date()).pattern("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04       <br>
    * (new Date()).pattern("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04       <br>
    * (new Date()).pattern("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04       <br>
    * (new Date()).pattern("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18       <br>
    */ 
    Date.prototype.pattern = function(fmt) {
    var o = {
    "M+": this.getMonth() + 1, //月份        
    "d+": this.getDate(), //日        
    "h+": this.getHours() % 12 == 0 ? 12 : this.getHours() % 12, //小时        
    "H+": this.getHours(), //小时        
    "m+": this.getMinutes(), //分        
    "s+": this.getSeconds(), //秒        
    "q+": Math.floor((this.getMonth() + 3) / 3), //季度        
    "S": this.getMilliseconds() //毫秒        
    };
    var week = {
    "0": "\u65e5",
    "1": "\u4e00",
    "2": "\u4e8c",
    "3": "\u4e09",
    "4": "\u56db",
    "5": "\u4e94",
    "6": "\u516d"
    };
    if ( /(y+)/ .test(fmt)) {
    fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
    if ( /(E+)/ .test(fmt)) {
    fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "\u661f\u671f" : "\u5468") : "") + week[this.getDay() + ""]);
    }
    for (var k in o) {
    if (new RegExp("(" + k + ")").test(fmt)) {
    fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    }
    }
    return fmt;
    };